import 'package:_private_core/utils/utils.dart';
import 'package:_private_core/widgets/widgets.dart';
import 'package:flutter/material.dart';

class WidgetLottieChat extends StatefulWidget {
  final double size;
  final String asset;
  const WidgetLottieChat({super.key, required this.size, required this.asset});

  @override
  State<WidgetLottieChat> createState() => _WidgetLottieChatState();
}

class _WidgetLottieChatState extends State<WidgetLottieChat>
    with SingleTickerProviderStateMixin {
  late final _controllerPlayOnce = AnimationController(vsync: this);

  @override
  void dispose() {
    super.dispose();
    _controllerPlayOnce.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return WidgetAppLottie(
      assetlottie('emoji/${widget.asset}'),
      controller: _controllerPlayOnce,
      onLoaded: (composition) {
        _controllerPlayOnce.duration = composition.duration;
        _controllerPlayOnce.forward();
      },
      package: '_private_chat',
      width: widget.size,
    );
  }
}
