import 'package:_private_core_network/network_resources/resources.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart'; 
import 'package:_private_chat/_private_chat.dart';
import 'package:_private_chat/constant.dart';

class WidgetProfileChatListBuilder extends StatelessWidget {
  final Widget Function(String fullname, String? thumbnal, Map conversationData)
      builder;
  final ChatConversationType conversationType;
  //Id of user or conversation
  final String id;
  const WidgetProfileChatListBuilder({
    super.key,
    required this.conversationType,
    required this.id,
    required this.builder,
  });

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<ChatListBloc, ChatListState>(
      bloc: chatListBloc,
      builder: (_, state) {
        String? fullname() {
          if (conversationType == ChatConversationType.solo) {
            CommonUserModel? user = state.getUserByKeys(id);
            return chatGetFullNameUser(user);
          } else {
            if (state.conversations.any((e) => e.conversationId == id)) {
              return state.conversations
                      .firstWhere((e) => e.conversationId == id)
                      .data[kDbGROUPNAME] ??
                  '';
            } else {
              return '';
            }
          }
        }

        String? thumbnail() {
          if (conversationType == ChatConversationType.solo) {
            CommonUserModel? user = state.getUserByKeys(id);
            return chatGetThumbnailUser(user);
          } else {
            if (state.conversations.any((e) => e.conversationId == id)) {
              return state.conversations
                      .firstWhere((e) => e.conversationId == id)
                      .data[kDbTHUMBNAIL] ??
                  '';
            } else {
              return '';
            }
          }
        }

        return builder(
            fullname() ?? "",
            thumbnail(),
            state.conversations.any((e) => e.conversationId == id)
                ? state.conversations
                    .firstWhere((e) => e.conversationId == id)
                    .data
                : {});
      },
    );
  }
}
