part of 'connection_status_bloc.dart';

abstract class ConnectionStatusEvent {}

class ConnectionStatusInitEvent extends ConnectionStatusEvent {
  final List<String> users;
  ConnectionStatusInitEvent(this.users);
}

class ConnectionStatusDisposeEvent extends ConnectionStatusEvent {}

class ConnectionStatusUpdateEvent extends ConnectionStatusEvent {
  final dynamic connectionStatusByKeys;
  final dynamic muted;
  final dynamic blocked;
  ConnectionStatusUpdateEvent({
    this.connectionStatusByKeys,
    this.blocked,
    this.muted,
  });
}

class ConnectionStatusSetStatusEvent extends ConnectionStatusEvent {
  bool? isOnline;
  ConversationStatus? conversationStatus;
  String? conversationId;
  ConnectionStatusSetStatusEvent({
    this.isOnline,
    this.conversationStatus,
    this.conversationId,
  });
}

class ConnectionStatusBlockToEvent extends ConnectionStatusEvent {
  String id;
  bool status;
  ConnectionStatusBlockToEvent(this.id, this.status);
}

class ConnectionStatusMuteToEvent extends ConnectionStatusEvent {
  String id;
  bool status;
  ConnectionStatusMuteToEvent(this.id, this.status);
}
