import 'package:_private_chat/constant.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart'; 
import 'package:_private_chat/_private_chat.dart';
import 'package:_private_chat/utils/utils.dart';

class WidgetUserConnectionStatusBuilder extends StatelessWidget {
  //personalStatus can is null => case don't use app
  //personalStatus can is bool => online
  //personalStatus is int if not online and that is lasttime login of user
  final Widget Function(
    dynamic personalStatus,
    ConversationStatus conversationStatus,
    String? conversationId,
    bool isBlockedFromMe,
    bool isMutedFromMe,
    bool isBlockedFromTheir,
    bool isMutedFromTheir,
  ) builder;
  final String id;
  const WidgetUserConnectionStatusBuilder({
    super.key,
    required this.id,
    required this.builder,
  });

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<ConnectionStatusBloc, ConnectionStatusState>(
      bloc: chatConnectionStatusBloc,
      buildWhen: (previous, current) {
        return previous.connectionStatusByKeys[id] !=
                current.connectionStatusByKeys[id] ||
            previous.blocked.contains(id) != current.blocked.contains(id) ||
            previous.muted.contains(id) != current.muted.contains(id);
      },
      builder: (_, state) {
        Map? data = state.connectionStatusByKeys[id];
        return builder(
          data?[kDbPERSONAL],
          ConversationStatus.values
              .byName(data?[kDbCONVERSATION] ?? ConversationStatus.none.name),
          data?[kDbCONVERSATIONID],
          state.blocked.contains(id),
          state.muted.contains(id),
          data?[kDbBLOCKED]?.contains(loggedFirebaseId) ?? false,
          data?[kDbMUTED]?.contains(loggedFirebaseId) ?? false,
        );
      },
    );
  }
}
