import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart'; 
import 'package:_private_chat/_private_chat.dart';
import 'package:_private_chat/constant.dart';

class WidgetUserReceivedStatusBuilder extends StatelessWidget {
  final Widget Function(int personalReceived) builder;
  final String id;
  const WidgetUserReceivedStatusBuilder({
    super.key,
    required this.id,
    required this.builder,
  });

  @override
  Widget build(BuildContext context) {
    return BlocBuilder<ConnectionStatusBloc, ConnectionStatusState>(
      bloc: chatConnectionStatusBloc,
      buildWhen: (previous, current) {
        return previous.connectionStatusByKeys[id]?[kDbPERSONALRECEIVED] !=
            current.connectionStatusByKeys[id]?[kDbPERSONALRECEIVED];
      },
      builder: (_, state) {
        return builder(
          state.connectionStatusByKeys[id]?[kDbPERSONALRECEIVED] ?? 0,
        );
      },
    );
  }
}
